/*
create by wangy
date:2016-03-02
desc:链接按钮
 */
require("../../sass/Base/Buttons/linkbutton.css");
require("../../sass/Base/Buttons/icon.css");
var React=require("react");
var LinkButton=React.createClass({
    propTypes: {
        name:React.PropTypes.string,//名称
        title:React.PropTypes.string,//标题
        backgroundColor:React.PropTypes.string,//背景图片
        iconCls:React.PropTypes.string,//图片
        iconAlign:React.PropTypes.oneOf([
            "left",
            "right",
            "rightTop"
        ]),//图片位置
        href:React.PropTypes.string,//链接地址
        onClick:React.PropTypes.func,//单击地址
        tip:React.PropTypes.string,//提示信息
        disabled:React.PropTypes.bool,//是否有效
    },
    getDefaultProps:function() {
        return{
            name:"",//关联值
            title:"",//标题
            backgroundColor:null,//背景颜色
            iconAlign:"left",//图标位置
            href:"javascript:void(0)",//连接地址
            iconCls:"",//默认为空
            onClick:null,//单击事件
            draggable:false,//是否允许拖动
            dragStartHandler:null,//拖动事件
            tip:""
        }
    },
    clickHandler:function() {
        if(this.props.disabled==true)
        {
            return ;
        }

        if(this.props.onClick!=null)
        {
            this.props.onClick(this.props.name,this.props.title);
        }
    },
    dragStartHandler:function(event) {
        event.dataTransfer.effectAllowed = "move";
        event.dataTransfer.setDragImage(event.target, 0, 0);
        var timestamp = Date.parse(new Date());

        var newLinkButton=<LinkButton  key={this.props.name+timestamp} name={this.props.name} title={this.props.title}
                                      iconCls={this.props.iconCls} iconAlign={this.props.iconAlign}  disabled={this.props.disabled}
                                           href={this.props.href}
                                      onClick={this.clickHandler}
                            ></LinkButton>

        this.props.dragStartHandler(newLinkButton,{name:this.props.name,
                                                        title:this.props.title,
                                                        iconCls: this.props.iconCls,
                                                        iconAlign:this.props.iconAlign,
                                                         disabled:this.props.disabled,
                                                          href:this.props.href,
                                                             onClick:this.clickHandler
                                                            });//传回父组件
        return true;
    },
    render:function() {

        var className = "linkbutton";
        var iconClass = "icon";
        var backgroundColor = null;
        if (this.props.backgroundColor) {
            className = "bigbutton";
            backgroundColor = this.props.backgroundColor;
        }
        if(this.props.className)
        {
            className+=" "+this.props.className;
        }
        var title=this.props.tip;
        if(title==""||!title)
        {
            title=this.props.title;
        }
        if (this.props.title =="") {
            return (<a draggable={this.props.draggable} onDragStart={this.dragStartHandler}
                       title={title}
                       href={this.props.href} onClick={this.clickHandler}
                       className={"onlyicon "} disabled={this.props.disabled} name={this.props.name}>
                <i className={"icon "+this.props.iconCls}></i>
            </a>);
        }
        else {

            if (this.props.iconAlign == "right") {
                return (

                    <a draggable={this.props.draggable} onDragStart={this.dragStartHandler}
                       title={title}
                       href={this.props.href} onClick={this.clickHandler} style={{backgroundColor:backgroundColor}}
                       className={className} disabled={this.props.disabled} name={this.props.name}>
                        <div className="text">{this.props.title}</div>
                        <i className={iconClass+" "+this.props.iconCls}
                           style={{display:this.props.iconCls==""?"none":"inline-block"}}></i>
                    </a>
                )
            }
            else if (this.props.iconAlign == "rightTop") {

                return (
                    <a draggable={this.props.draggable} onDragStart={this.dragStartHandler}
                       title={title}
                       href={this.props.href} onClick={this.clickHandler} style={{backgroundColor:backgroundColor}}
                       className={className} disabled={this.props.disabled} name={this.props.name}>
                        <div className="text">{this.props.title}</div>
                        <i className={iconClass+" "+this.props.iconCls+" rightTop"}
                           style={{display:this.props.iconCls==""?"none":"inline-block"}}></i>
                    </a>);

            }
            else {
                return (

                    <a draggable={this.props.draggable} onDragStart={this.dragStartHandler}
                       title={title}
                       href={this.props.href} onClick={this.clickHandler} className={className}
                       style={{backgroundColor:backgroundColor}}
                       disabled={this.props.disabled} name={this.props.name}>
                        <i className={iconClass+" "+this.props.iconCls}
                           style={{display:this.props.iconCls==""?"none":"inline-block"}}></i>
                        <div className="text">{this.props.title}</div>

                    </a>

                )
            }

        }

    }
});
module .exports=LinkButton;7