//create by wangzy
//date:2016-02-18
//标签页组
require("../../sass/Base/Layout/MenuTabs.css");
var React =require("react");
var Tab=require("./MenuTab.jsx");
var TabSection=require("./MenuTabSection.jsx");
var Tabs=React.createClass({
        propTypes:{
            tabs:React.PropTypes.array,
            menuHandler:React.PropTypes.func.isRequired,//菜单按钮的单击事件
            tabNumChangeHandler:React.PropTypes.func.isRequired,//标签页数据发生改变事件
        },
        getDefaultProps: function () {
            return {
                tabs: []
            }
        },
     getInitialState: function () {
        return {
            tabs: this.props.tabs
        };
    },
        menuHandler:function() {//显示/隐藏菜单的事件
              this.props.menuHandler();//回调父组件
        },
        componentWillReceiveProps:function(nextProps) {
          this.setState({
              tabs:nextProps.tabs

          })
        },
        tabClickHandler:function(index) {
            //页签单击事件.激活
            var newTabs = this.state.tabs;
            //当前激动的tab下标保存
            for (var i = 0; i < newTabs.length; i++) {
                if (i == index) {
                    newTabs[index].active = true;
                }
                else {
                    newTabs[i].active = false;
                }
            }
            this.setState({tabs: newTabs});
        },
        tabCloseHandler:function(index) {
            //改变了数据结构，必需回传给父组件
            var newTabs = this.state.tabs;
            var parentuuid=newTabs[index].parentuuid;
            var parentIndex=null;//父页面的下标
            for(var i=0;i<newTabs.length;i++) {
                if(newTabs[i].uuid==parentuuid)
                {
                    parentIndex=i;
                    break;
                }
            }
            if(newTabs[index].active==true)
            { //删除tab为激活的tab
                if(parentIndex!=null)
                {//存在父页面，父页面激活
                    newTabs[parentIndex].active=true;
                }
                else {//不存在父页面，激活临近页面
                    if (index < newTabs.length - 1) {//不是最后一个，下一个激活
                        newTabs[index + 1].active = true;

                    }
                    else {
                        //最后一个，上一个激活
                        if (index != 0) {
                            newTabs[index - 1].active = true;
                        }
                        else {
                        }

                    }
                }
            }
            newTabs.splice(index, 1);//删除
            this.setState({
                tabs:newTabs
            })
            if (this.props.tabNumChangeHandler) {
                this.props.tabNumChangeHandler(newTabs);//返回给你父组组件更新
            }
        },
        render:function () {
            var tabobj = [];
            var sectionobj = [];
            var tabclickHandler=this.tabClickHandler;
            var tabCloseHandler=this.tabCloseHandler;
            this.state.tabs.map(function (child,i) {
                if(child.active==true)
                {//保存当前激活标签uuid，用于子标签中打开新标签时设置其父标签
                    window.localStorage.setItem("alog_currentTabUUID",child.uuid);//保存当前激活节点，用于新建tab
                    if(child.parentuuid!=null)
                    {
                        var   parentTabUUID=window.localStorage.getItem("parentTabUUID");
                        if(parentTabUUID==null)
                        {
                            parentTabUUID="";
                        }
                        parentTabUUID+=child.uuid+"$"+ child.parentuuid;//);//保存当前激活节点的uuid及父节点的uuid,用于关闭tab时刷新父节点,
                        window.localStorage.setItem("parentTabUUID",parentTabUUID);
                    }

                }
                tabobj.push(<Tab key={"tab"+i} index={i} title={child.title}
                                 active={child.active} clickHandler={tabclickHandler} closeHandler={tabCloseHandler}></Tab>);
                sectionobj.push(<TabSection key={"tabsection"+i} url={child.url}
                                            active={child.active} content={child.content}></TabSection>);
            });

            return (
                <div>
                 <ul className="nav nav-tabs">
                     <li className="tabmenu" onClick={this.menuHandler}></li>
                     <li className="tabhome"></li>
                    {tabobj}</ul>
                    { sectionobj}
                </div>);

        }
    } );
module.exports=Tabs;
